﻿

RT_Buttons = {
	LastPage = { },
	QuickLooter = { "disenchant", "bank" },
	funcMenuOnClick	= function( frame ) RT_Buttons:Menu_OnClick(frame); end,
	addItemInfo = { func = nil, value = { }, },
};


function RT_Buttons:ShowDialog( frameName, type, raidid, itemid, what, zone, player, boss )
	local frame = _G[frameName];
	if not frame then return nil end;
	if type then frame.type = type; end
    if what then frame.what = what; end
    if raidid then frame.raidid = raidid; end
    if itemid then frame.itemid = itemid; end
    if zone then frame.zone = zone; end
    if player then frame.player = player; end
    if boss then frame.boss = boss; end
    frame:Show();
end

function RT_Buttons:AddItem( level, type1, what, title, text, onClick, value, checked, hasArrow )
	local info = self.addItemInfo;
	if onClick==nil then onClick=true end
	local e = type(onClick)
	value = value or { }
	if info.value then
		for i,v in pairs(info.value) do
			if not value[i] then value[i] = v end
		end
	end
	
	info.text = title .. (text and ("("..text..")") or "");
	info.func = (e == "function") and onClick or (onClick and self.funcMenuOnClick or nil);
	info.checked = checked and true or nil;
	info.hasArrow = hasArrow and true or nil;
	info.keepShownOnClick = (hasArrow and (e ~= "string")) and true or nil
   	value.type = (type1) and type1 or value.type
   	value.what = what
   	value.title = title
   	value.value = text	
   	value.frameName = (e == "string") and onClick or nil

	info.value, value = value, info.value;
	UIDropDownMenu_AddButton(info, level);
	info.value = value;
end

function RT_Buttons:GetPlayerGroups( raidid )
    local raid = KARaidTrackerDB.RaidLog[raidid];
	if not raid then return { }; end 
	-- make list without duplicates: indexes
	local indexes = { };
	local groups = { };
	local found = nil;
	
	for k, v in pairs(raid.Join) do
		if v.player then
			found = false;
			for k2, v2 in pairs(indexes) do
				if v2 == v.player then
					found = true;
					break;
				end
			end
			if not found then
				tinsert(indexes, v.player);
			end
		end
	end
	table.sort(indexes);
	-- hash the list by first letter
	for k, v in pairs(indexes) do
		local group = (KarmaUtility.SpecialCharsTable[strsub(v, 1, 2)] or v);						-- if a special char get that
		group = strupper(strsub(group, 1, 1));
		if not groups[group] then
			groups[group] = { };
		end
		tinsert(groups[group], v);
	end	
	return groups;
end


-- ********************** Rarity Button **************************

RT_RarityDropdown = {

}

function RT_RarityDropdown:OnUpdate( )
	local id = KARaidTrackerDB.SortOptions[ RaidTrackerFrame.type .. "filter" ];
	UIDropDownMenu_SetSelectedID( RT_RarityDropdownFrame, id );
	RT_RarityDropdownFrameText:SetText( RaidTracker_Options.desc.rarity[ id ] );
end

function RT_RarityDropdown:OnLoad( frame )
	UIDropDownMenu_Initialize( frame, function ( frame )
			for i = 1, #RaidTracker_Options.desc.rarity -1 do
				if i > 0 then
					RT_Buttons:AddItem( nil, "rarity", nil, RaidTracker_Options.desc.rarity[i] );
				end		
			end
		end );
	UIDropDownMenu_SetSelectedID( frame, 1 );
end


-- ************** right click menus **************

function RT_Buttons:Menu_Toggle( frame )
	local dropdown = getglobal(frame:GetName().."RightClickMenu");
	dropdown.point = "TOPLEFT";
	dropdown.relativePoint = "BOTTOMLEFT";
	ToggleDropDownMenu(1, nil, dropdown, "cursor", 0, 0);
end

function RT_Buttons:Menu_OnClick( frame )
	KARaidTracker:DebugTable("Menu_OnClick", frame:GetName(), frame.value );
	local value = frame.value
	if not value then return end
	if value.frameName then
		self:ShowDialog(value.frameName, value.type, value.raidid, value.itemid, value.what, value.zone, value.player, value.boss);
	else
		if value.type == "rarity" then
			KARaidTrackerDB.SortOptions[ RaidTrackerFrame.type .. "filter" ] = frame:GetID();
			KA_RaidTracker_UpdateView( );
		elseif value.type == "zone" then
			KARaidTrackerDB.RaidLog[value.raidid].zone = value.zone;
			KA_RaidTracker_Update();
			KA_RaidTracker_UpdateView();
		elseif value.type == "looter" then
			KARaidTrackerDB.RaidLog[value.raidid].Loot[value.itemid].player = value.player;
			KA_RaidTracker_UpdateView();
		elseif value.type == "boss" then
			KARaidTrackerDB.RaidLog[value.raidid].Loot[value.itemid].boss = value.boss;
			KA_RaidTracker_UpdateView();
		else
			return;
		end
		HideDropDownMenu(2)
	end
end

function RT_RaidItemTemplate_RightClickMenu_Initialize( frame, level )
	if not level then return end;	
	local db = KARaidTrackerDB
	local raidid = frame:GetParent().raidid;
	local raid = db.RaidLog[raidid];
	if not raid then return end
--	KARaidTracker:Debug("level("..level..")", raidid, this:GetID(), frame:GetName());	
	
	if level == 1 then
		RT_Buttons.addItemInfo.value = { raidid = raidid }
		local value = RT_Buttons.addItemInfo.value;
		
		RT_Buttons:AddItem( level, "time", "raidstart", "Edit Start", raid.key, "RT_EditNoteFrame" );
		RT_Buttons:AddItem( level, "time", "raidend", "Edit End", raid.End, "RT_EditNoteFrame" );
		RT_Buttons:AddItem( level, "zone", nil, "Edit Zone", raid.zone, "RT_EditNoteFrame", nil, raid.zone and db.ZoneTriggers[raid.zone], true );
		RT_Buttons:AddItem( level, "raidnote", nil, "Edit Note", raid.note, "RT_EditNoteFrame" );
		RT_Buttons:AddItem( level, "export", nil, "Show Export String", nil, "RT_ExportFrame" );
		
	elseif level == 2 then
		RT_Buttons.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Buttons.addItemInfo.value
		if not value then return end;

		if value.type == "zone" then
			local L = KARaidTracker._acelib.L;
			for k, v in ipairs(RaidTracker_GameReleases) do
				checked = nil;
				for k1, v1 in pairs(RaidTracker_ZoneTriggers) do
					if v1.rel == v and k1 == raid.zone then checked = true; end
				end
				RT_Buttons:AddItem( level, nil, nil, L[RaidTracker_Tags["REL"..v]], nil, nil, {release = v}, checked, true )
			end
			if getn(db.ZoneTriggers) > 0 then UIDropDownMenu_AddButton( {disabled = 1}, level ) end
			for k, v in pairs(db.ZoneTriggers) do
				RT_Buttons:AddItem( level, nil, nil, L[k], nil, nil, {zone = k}, raid.zone == k );
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level );
			RT_Buttons:AddItem( level, nil, nil, "None", nil, nil, {zone = nil}, raid.zone == nil);									
		end
		
	elseif level == 3 then
		RT_Buttons.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Buttons.addItemInfo.value
		if not value then return end;

		if value.type == "zone" then
			local L = KARaidTracker._acelib.L;
			local zones = { };
			for k, v in pairs(RaidTracker_ZoneTriggers) do
				if value.release == v.rel then
					tinsert( zones, v );
				end
			end
			local rt = KARaidTracker;
			table.sort(zones, function(a, b) return a.pid < b.pid; end);
			for k, v in pairs(zones) do
				local title = L[v.name] .. (v.ran and ("  |c0099ccff("..v.ran..")|r") or "");
				RT_Buttons:AddItem(level, nil, nil, title, nil, nil, {zone = v.name}, raid.zone == v.name)
			end
		end
	end
end

function RT_LootItemTemplate_RightClickMenu_Initialize( frame, level )
	if not level then return end;	
	local db = KARaidTrackerDB
	local raidid = frame:GetParent().raidid;
	local itemid = frame:GetParent().itemid;
	local raid = db.RaidLog[raidid];
	if not raid then return end
	local item = itemid and raid.Loot[itemid] or nil
--	KARaidTracker:Debug("level("..level..")", raidid, itemid);
	
	local checked = nil;

	if level == 1 then
		RT_Buttons.addItemInfo.value = { raidid=raidid, itemid=itemid }
		local value = RT_Buttons.addItemInfo.value;

		RT_Buttons:AddItem( level, "looter", nil, "Edit Looter", item.player, "RT_EditNoteFrame", nil, nil, true );
		RT_Buttons:AddItem( level, "itemcost", nil, "Edit Cost", item.costs, "RT_EditCostFrame" );
		RT_Buttons:AddItem( level, "itemcount", nil, "Edit Count", item.item.count, "RT_EditNoteFrame" );
		RT_Buttons:AddItem( level, "time", "item", "Edit Time", item.time, "RT_EditNoteFrame" );
		RT_Buttons:AddItem( level, "boss", nil, "Dropped from:", item.boss or "none", false, { cboss=item.boss }, item.boss, true );
		
	elseif level == 2 then	
		RT_Buttons.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Buttons.addItemInfo.value
		if not value then return end

		if value.type == "looter" then
			for k, v in pairs(RT_Buttons.QuickLooter) do
				RT_Buttons:AddItem( level, nil, nil, v, nil, nil,  nil, item.player == v );
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level );
			PlayerGroups = RT_Buttons:GetPlayerGroups( raidid );
			for k, v in KARaidTracker:sortedpairs(PlayerGroups) do
				checked = nil;
				for k2, v2 in pairs(v) do
					if item.player == v2 then checked = 1; break end
				end
				RT_Buttons:AddItem( level, nil, nil, k, nil, false,  { players=v }, checked, true );
			end
		elseif value.type == "boss" then
			RT_Buttons:AddItem( level, nil, nil, "None", nil, nil,  nil, value.cboss == nil );
			for k, v in pairs(RaidTracker_Bosses) do
				if type(v) ~= "table"  then
					RT_Buttons:AddItem( level, nil, nil, k, nil, nil,  { zone=value.zone, boss=k }, value.cboss == v );
				end
			end
			UIDropDownMenu_AddButton( { disabled = 1 }, level );
			for k, v in pairs(RaidTracker_Bosses) do
				if type(v) == "table"  then
					checked = nil
					if value.cboss then
						for k2, v2 in pairs(RaidTracker_Bosses[k]) do
							if value.cboss == v2 then checked = 1; break; end
						end
					end
					RT_Buttons:AddItem( level, nil, nil, k, nil, false,  { zone=k, cboss=value.cboss }, checked, true );
				end
			end
		end

	elseif level == 3 then
		RT_Buttons.addItemInfo.value = UIDROPDOWNMENU_MENU_VALUE
		local value = RT_Buttons.addItemInfo.value
		if not value then return end;

		if value.type == "looter" then
			for k, v in pairs(value.players) do
				RT_Buttons:AddItem( level, nil, nil, v, nil, nil,  { player=v }, item.player == v );
			end
		elseif value.type == "boss" then
			for k, v in pairs(RaidTracker_Bosses[value.zone]) do
				if type(v) == "table" then
					for k2, v2 in pairs(v) do
						RT_Buttons:AddItem( level, nil, nil, k..' - '..v2, nil, nil,  { zone=value.zone, boss=v2 }, value.cboss == v );
					end;
				else
					RT_Buttons:AddItem( level, nil, nil, v, nil, nil,  { zone=value.zone, boss=v }, value.cboss == v );
				end
			end
		end
	end
	
end


-- Next Boss selection handling
function RT_BossNextFrame_Menu_Initialize( frame, level )
    local db = KARaidTrackerDB

	local i = 0;
	local ii = 0;
	if (db.Options.CurrentRaid == nil) then
		return;
	end;

	i = KA_RaidTracker_Boss_Add_Button(RaidTracker_BossUnitTriggers["DEFAULTBOSS"],i);
	ii = ii + 1;
	if (db.RaidLog[db.Options.CurrentRaid].zone == nil) then
		for k,v in pairs(RaidTracker_Bosses) do
				KarmaUtility:Debug(k,v);
			if (v == 1) then
				ii = ii + 1;
				for k2,v2 in pairs(RaidTracker_BossUnitTriggers) do
					if (v2 == v) then
						i = KA_RaidTracker_Boss_Add_Button(k2,i);
					end;
				end;
			end;
		end
	else
		for k,v in pairs(RaidTracker_Bosses[db.RaidLog[db.Options.CurrentRaid].zone]) do
			local addit = true;
			for k2,v2 in pairs(db.RaidLog[db.Options.CurrentRaid].BossKills) do
				if (v2.boss == v) then
					addit = false;
				end;
			end;
			if (addit == true) then
				if (type(v) == "table") then
					for k2,v2 in pairs(v) do
						ii = ii + 1;
						for k3,v3 in pairs(RaidTracker_BossUnitTriggers) do
							if (v3 == v2) then
								i = KA_RaidTracker_Boss_Add_Button(k..' - '..k3,i);
							end;
						end;
					end;
				else
					ii = ii + 1;
					for k2,v2 in pairs(RaidTracker_BossUnitTriggers) do
						if (v2 == v) then
							i = KA_RaidTracker_Boss_Add_Button(k2,i);
						end;
					end;
				end;
			end;
		end
	end;
	if (ii == 2) then
		UIDropDownMenu_SetSelectedID(RT_BossNextFrameBossDropdown, ii);
	end;
end;

function KA_RaidTracker_Boss_Add_Button(k,i)
	local info = {
		text = k;
		func = KA_RaidTracker_Boss_Update;
	};
	UIDropDownMenu_AddButton(info);
	if (i == cur_class_id) then
		UIDropDownMenu_SetSelectedID(RT_BossNextFrameBossDropdown, i+1);
		UIDropDownMenu_SetText(info.text, RT_BossNextFrameBossDropdown);
	end
	return i
end;

function KA_RaidTracker_Boss_Update( )
	i = this:GetID();
	UIDropDownMenu_SetSelectedID(RT_BossNextFrameBossDropdown, i);
end;
