-- Raid Item Maintainance Dialog


RT_ItemOptions = {

}


function RT_ItemOptions:GetItem( frame )
 	return KARaidTrackerDB.ItemOptions[frame.itemid];
end


function RT_ItemOptions:GetDispName( item )
	local text;
	if item.name then
		local _, _, _, color = GetItemQualityColor(item.quality);
		text = color..item.name;
	else
		text = "Unknown (ID: "..item.id..")";
	end
	return text;
end


function RT_ItemOptions:GetCheckedVal( element, element2 )
    if element:GetChecked() == 1 then
        return 1;
    elseif element2:GetChecked() == 1 then
		return 0;
    end
	return nil;
end


function RT_ItemOptions:ScrollBar_Update( )
	local db = KARaidTrackerDB

	local sortedKeys = KarmaUtility:TableGetKeys(db.ItemOptions);
	local nline, nlineofs;
	local maxlines = getn(sortedKeys);
	
	FauxScrollFrame_Update(RT_ItemOptionsFrame_ScrollBar, maxlines, 24, 14);
	for nline=1, 24 do
		local line = getglobal("RT_ItemOptionsFrame_Entry"..nline);
		nlineofs = nline + FauxScrollFrame_GetOffset(RT_ItemOptionsFrame_ScrollBar);
		local item = (nlineofs <= maxlines) and db.ItemOptions[sortedKeys[nlineofs]];
		if item then
	    	line.id = nlineofs;
	    	line.itemid = item.id;
	    	local nameGIF, linkGIF, qualityGIF, LevelGIF, minLevelGIF, classGIF, subclassGIF, maxStackGIF, invtypeGIV, iconGIF = GetItemInfo(item.id);
	    	if nameGIF then
	    		item.name = nameGIF;
	    		item.quality = qualityGIF;
	    	end
			line:SetText(self:GetDispName(item));
			line:Show();
			if(db.Options["ItemOptionsSelected"] == nlineofs) then
				getglobal("RT_ItemOptionsFrame_Entry"..nline.."MouseOver"):Show();
			else
				getglobal("RT_ItemOptionsFrame_Entry"..nline.."MouseOver"):Hide();
			end
	    else
			line:Hide();
			getglobal("RT_ItemOptionsFrame_Entry"..nline.."MouseOver"):Hide();
		end
	end
end


function RT_ItemOptions:Delete(frame)
	local db = KARaidTrackerDB
	local opts = db.Options;

	db.ItemOptions[frame.itemid] = nil;
	if opts.ItemOptionsSelected then
		if opts.ItemOptionsSelected == frame.id then
			opts.ItemOptionsSelected = nil;
		elseif opts.ItemOptionsSelected > frame.id then
			opts.ItemOptionsSelected = opts.ItemOptionsSelected - 1;
		end
	end
	RT_ItemOptionsFrame_Edit:Hide();
	RT_ItemOptions:ScrollBar_Update();
end


function RT_ItemOptions:SetFrame( frame )
	local db = KARaidTrackerDB
	RT_ItemOptionsFrame_Edit:Hide();
	RT_ItemOptionsFrame_Edit.id = frame.id;
	RT_ItemOptionsFrame_Edit.itemid = frame.itemid;
	RT_ItemOptionsFrame_Edit_Item:SetText(self:GetDispName(self:GetItem(frame)));
	RT_ItemOptions:Edit_OnShow(frame);
	RT_ItemOptionsFrame_Edit:Show();
end


function RT_ItemOptions:Edit_OnShow( frame )
	local item = self:GetItem(frame);
	
	RT_ItemOptionsFrame_Edit_TrackDefault:SetChecked(	not item.Track		and 1 or 0 );
	RT_ItemOptionsFrame_Edit_TrackAlways:SetChecked(	item.Track == 1		and 1 or 0 );
	RT_ItemOptionsFrame_Edit_TrackNever:SetChecked(		item.Track == 0		and 1 or 0 );

	RT_ItemOptionsFrame_Edit_GroupDefault:SetChecked(	not item.Group		and 1 or 0 );
	RT_ItemOptionsFrame_Edit_GroupAlways:SetChecked(	item.Group == 1		and 1 or 0 );
	RT_ItemOptionsFrame_Edit_GroupNever:SetChecked(		item.Group == 0		and 1 or 0 );

	RT_ItemOptionsFrame_Edit_GetCostDefault:SetChecked(	not item.CostGet	and 1 or 0 );
	RT_ItemOptionsFrame_Edit_GetCostAlways:SetChecked(	item.CostGet == 1	and 1 or 0 );
	RT_ItemOptionsFrame_Edit_GetCostNever:SetChecked(	item.CostGet == 0	and 1 or 0 );

	RT_ItemOptionsFrame_Edit_CostAskDefault:SetChecked(	not item.CostAsk	and 1 or 0 );
	RT_ItemOptionsFrame_Edit_CostAskAlways:SetChecked(	item.CostAsk == 1	and 1 or 0 );
	RT_ItemOptionsFrame_Edit_CostAskNever:SetChecked(	item.CostAsk == 0	and 1 or 0 );
end


function RT_ItemOptions:Edit_Save( frame )
	local item = KarmaUtility:TableAddUnique(KARaidTrackerDB.ItemOptions, frame.itemid, self:GetItem(frame), true);	-- propagate default values to database
	
	item.Track = self:GetCheckedVal(	RT_ItemOptionsFrame_Edit_TrackAlways,	RT_ItemOptionsFrame_Edit_TrackNever  );
	item.Group	= self:GetCheckedVal(	RT_ItemOptionsFrame_Edit_GroupAlways,	RT_ItemOptionsFrame_Edit_GroupNever  );
	item.CostGet = self:GetCheckedVal(	RT_ItemOptionsFrame_Edit_GetCostAlways,	RT_ItemOptionsFrame_Edit_GetCostNever);
	item.CostAsk = self:GetCheckedVal(	RT_ItemOptionsFrame_Edit_CostAskAlways,	RT_ItemOptionsFrame_Edit_CostAskNever);
end